﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace HMI2
{
    public partial class TestWindow
    {
        public void FlashMemory_GetID()
        {
            UInt32[] spiData = new UInt32[4] { 0x9f, 0x00, 0x00, 0x00 };
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 4);
            }
        }


        public void FlashMemory_WriteEnable()
        {
            UInt32[] spiData = new UInt32[1] { 0x06 };
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 1);
            }

        }


        public void FlashMemory_WriteDisable()
        {
            UInt32[] spiData = new UInt32[1] { 0x04 };
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 1);
            }

        }


        public UInt32 FlashMemory_ReadStatusRegister()
        {
            UInt32[] spiData = new UInt32[2] { 0x05, 0x00 };
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 2);
                return (rxBuffer[1]);
            }

        }


        public void FlashMemory_EnableWriteStatusRegister()
        {
            UInt32[] spiData = new UInt32[1] { 0x50 };
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 1);
            }

        }


        public void FlashMemory_WriteStatusRegister(UInt32 Val)
        {
            UInt32[] spiData = new UInt32[2];
            spiData[0] = 0x01;
            spiData[1] = Val;
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 2);
            }

        }


        public void FlashMemory_ChipErase()
        {
            UInt32[] spiData = new UInt32[1] { 0x60 };
            FlashMemory_WriteEnable();
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 1);
            }

        }


        public void FlashMemory_SectorErase_4K()
        {
            UInt32[] spiData = new UInt32[4] { 0x20, 0x00, 0x00, 0x00 };
            FlashMemory_WriteEnable();
            unsafe
            {
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 4);
            }

        }


        public void FlashMemory_WriteByte(UInt32 Address, UInt32 Data)
        {
            UInt32[] spiData = new UInt32[5];
            FlashMemory_WriteEnable();
            unsafe
            {
                spiData[0] = 0x02;
                spiData[1] = ((Address & 0x000f0000) >> 16);
                spiData[2] = ((Address & 0x0000ff00) >> 8);
                spiData[3] = (Address & 0x000000ff);
                spiData[4] = Data;
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 5);
            }

        }


        public void FlashMemory_ReadData(UInt32 Address, UInt32 DataBytes)
        {
            UInt32[] spiData = new UInt32[300];
            FlashMemory_WriteEnable();
            unsafe
            {
                spiData[0] = 0x03;
                spiData[1] = ((Address & 0x000f0000) >> 16);
                spiData[2] = ((Address & 0x0000ff00) >> 8);
                spiData[3] = (Address & 0x000000ff);
                fixed (UInt32* rxBuffer1 = rxBuffer)
                fixed (UInt32* spiData1 = spiData)
                    spi.Spi_ReadWrite(SPI_handle, (IntPtr)rxBuffer1, (IntPtr)spiData1, 4+DataBytes);
            }

        }


        public void FlashMemory_BusyCheck()
        {
            ReadVal = FlashMemory_ReadStatusRegister();
            while ((ReadVal & 0x01) == 0x01)
            {
                ReadVal = FlashMemory_ReadStatusRegister();
            }
        }


    }
}
